<template>
<div v-if="tab === 'all-user'" class="">
  <SearchSettings @search="search" hint="Поиск производится по логину пользователя" />
  <q-spinner-gears
      v-show="!users.length"
      color="primary"
      size="8em"
      class="mx-auto mt-12"
  />
  <q-list>
    <div v-for="user in users" :key="user._id">
      <q-item clickable @click="editUserModal = user._id" class="flex items-center" :class="{'bg-red-100': !user.status}">
        <div class="mr-4 w-24 inline-block h-4 text-center rounded bg-blue-300 text-gray-600">{{typeof user.roles === 'object' && useTranslitRoles(user.roles[0]) || useTranslitRoles(user.roles)}}</div>
        <p class="text-xl">{{user.username}}</p>
        <p v-if="!user.status" class="text-red mt-1 ml-auto opacity-70 italic">Заблокирован</p>
      </q-item>
      <Modal v-if="user._id === editUserModal" @close="editUserModal = ''">
        <template v-slot:body>
          <div>
            <q-list>
              <div class="grid grid-rows-2 grid-cols-2">
                <q-item class="items-center">Логин: <q-input dark v-model="user.username" dense class="ml-4" /></q-item>
                <q-item class="items-center">Имя: <q-input dark v-model="user.name" dense class="ml-4" /></q-item>
                <q-item class="items-center">Фамилия: <q-input dark v-model="user.surname" dense class="ml-4" /></q-item>
                <q-item class="items-center">Отчество: <q-input dark v-model="user.patronymic" dense class="ml-4" /></q-item>
              </div>
              <q-separator class="my-6" dark/>
              <div class="grid grid-rows-1 grid-cols-2">
                <q-item class="items-center">Телефон: <q-input dark v-model="user.phone" dense class="ml-4" /></q-item>
                <q-item class="items-center">Email: <q-input dark v-model="user.email" dense class="ml-4" /></q-item>
              </div>
              <q-separator class="my-6" dark/>
              <div class="grid grid-rows-1 grid-cols-2">
                <q-item class="items-center">Роль:
                  <q-select class="ml-4"
                            v-model="user.roles"
                            :options="roles"
                            :model-value="user.roles"
                            dense dark
                            option-label="value"
                  >
                    <template v-slot:option="{ itemProps, opt, selected, toggleOption }">
                      <q-item v-bind="itemProps" @update:model-value="opt">
                        <q-item-section>
                          <q-item-label v-close-popup v-html="useTranslitRoles(opt)"/>
                        </q-item-section>
                      </q-item>
                    </template>
                    <template v-slot:selected>
                      {{typeof user.roles === 'object' && useTranslitRoles(user.roles[0]) || useTranslitRoles(user.roles)}}
                    </template>
                  </q-select>
                </q-item>
                <q-item class="items-center">Пароль: <q-input dark v-model="user.password" dense class="ml-4" /></q-item>
              </div>
              <div class="grid grid-rows-1 grid-cols-2">
                <q-item v-if="user.roles[0] === 'LEADSMAN'" class="items-center">Видит: <q-input
                    dark
                    v-model="user.leadsman"
                    dense
                    class="ml-4"
                    hint="Сайт откуда приходит лид, пользователь будет видет те лиды, которые тут напишите"
                /></q-item>
              </div>
              <div class="float-right mt-8 flex items-center">
                <q-btn :label="user.status && 'Заблокировать' || 'Разблокировать'"
                       :color="user.status && 'red' || 'green'"
                       class="mr-4"
                       @click="blackBlockUser(user._id)"
                />
                <q-btn label="Сохранить"
                       color="green"
                       @click="save(user)"
                />
              </div>
            </q-list>
          </div>
        </template>
      </Modal>
    </div>
  </q-list>
</div>
<div v-else class="">
  <div v-if="!isAddUser" class="pb-8">
    <q-list>
      <div class="grid lg:grid-rows-2 lg:grid-cols-2">
        <q-item class="items-center">Логин: <q-input v-model="newUser.username" dense class="w-full lg:w-1/2 ml-4" hint="не менее 4 символов" /></q-item>
        <q-item class="items-center">Имя: <q-input v-model="newUser.name" dense class="w-full lg:w-1/2 ml-4" /></q-item>
        <q-item class="items-center">Фамилия: <q-input v-model="newUser.surname" dense class="w-full lg:w-1/2 ml-4" /></q-item>
        <q-item class="items-center">Отчество: <q-input v-model="newUser.patronymic" dense class="w-full lg:w-1/2 ml-4" /></q-item>
      </div>
      <q-separator class="my-6"/>
      <div class="grid grid-rows-1 grid-cols-2">
        <q-item class="items-center">Телефон: <q-input v-model="newUser.phone" dense class="ml-4" /></q-item>
        <q-item class="items-center">Email: <q-input v-model="newUser.email" dense class="ml-4" /></q-item>
      </div>
      <q-separator class="my-6"/>
      <div class="grid grid-rows-1 grid-cols-2">
        <q-item class="items-center">Роль:
          <q-select class="ml-4"
                    v-model="newUser.roles"
                    :options="roles"
                    :model-value="newUser.roles"
                    dense
                    option-label="value"
          >
            <template v-slot:option="{ itemProps, opt, selected, toggleOption }">
              <q-item v-bind="itemProps" @update:model-value="opt">
                <q-item-section>
                  <q-item-label v-close-popup v-html="useTranslitRoles(opt)"/>
                </q-item-section>
              </q-item>
            </template>
            <template v-slot:selected>
              {{typeof newUser.roles === 'object' && useTranslitRoles(newUser.roles[0]) || useTranslitRoles(newUser.roles)}}
            </template>
          </q-select>
        </q-item>
        <q-item class="items-center">Пароль: <q-input v-model="newUser.password" hint="не менее 4 символов" dense class="ml-4" /></q-item>
      </div>
      <q-btn label="Сохранить"
             color="green"
             class="ml-auto block my-8"
             @click="addUser"
             :disable="newUser.password.length < 4 || newUser.username.length < 4"
      />
    </q-list>
    <q-slide-transition>
      <q-card v-show="error.length" class="p-8 flex items-center justify-items-center no-wrap w-full lg:w-1/2 mx-auto">
        <q-icon name="error" color="red" size="lg" class="mr-6"/> {{error}}
      </q-card>
    </q-slide-transition>
  </div>
  <div v-else>
    <q-card class="p-8 flex items-center justify-items-center no-wrap w-full lg:w-1/2 mx-auto">
      <q-icon name="how_to_reg" color="green" size="lg" class="mr-6"/> Пользователь успешно добавлен
    </q-card>
    <q-btn @click="showSuccessAddUser" label="ok" class="block mx-auto my-6" />
  </div>
</div>
</template>

<script>
import {ref, watch} from "vue";
import api from "../../API/api";
import Modal from "../../components/Modal.vue";
import useTranslitRoles from "../../components/useTranslitRoles"
import SearchSettings from "./Search-settings.vue";

let stringOptions = [].reduce((acc, opt) => {
  for (let i = 1; i <= 5; i++) {
    acc.push(opt + ' ' + i)
  }
  return acc
}, [])

export default {
  name: "User-settings",
  components: {SearchSettings, Modal},
  props: {
    tab: {type: String},
  },
  setup (prop) {
    const users = ref([])
    const newUser = ref({
      username: '',
      name: '',
      surname: '',
      patronymic: '',
      phone: '',
      email: '',
      roles: [],
      password: '',
    })
    const isAddUser = ref(false)
    const error = ref('')
    const roles = ref([])
    const editUserModal = ref('')

    api.getUsers().then(r => {
      users.value = r.data.users
      stringOptions = r.data.users
    })
    api.getRoles().then(r => {
      roles.value = r.data.roles.map(obj => obj.value);
    })
    function search (value) {
      const needle = value.toLocaleString().toLocaleLowerCase()
      users.value = stringOptions.filter(v => v.username.toLocaleLowerCase().indexOf(needle) > -1)
    }

    async function save (user) {
      typeof user.roles !== 'object' && (user.roles = [user.roles])
      await api.changeUser(user).then(() => editUserModal.value = '')
    }
    async function blackBlockUser (_id) {
      await api.blackBlockUser({_id}).then(() => {
        users.value.forEach(e => e._id === _id && (e.status = !e.status))
      })
    }
    async function addUser () {
      await api.addUser(newUser.value)
        .then(() => {
          isAddUser.value = true
        })
        .catch(er => {
          error.value = er.response.data.message
        })
    }
    return {
      users,
      newUser,
      isAddUser,
      error,
      roles,
      search,
      editUserModal,
      useTranslitRoles,
      blackBlockUser,
      save,
      addUser,
      showSuccessAddUser: function () {
        isAddUser.value = false
        newUser.value = {
          username: '',
          name: '',
          surname: '',
          patronymic: '',
          phone: '',
          email: '',
          roles: [],
          password: '',
        }
      }
    }
  }
}
</script>

<style scoped>

</style>